program amo_adj_exec
  use sep
  use amo_time_freq_mod
  use amo_zero_mod
  use sep3d_struct_mod
  use transp_data_mod
  implicit none
  type(sep3d)        :: time_irreg_s 
  type(sep3d)        :: freq_irreg_s 
  type(sep3d)        :: headers_s 
  type(sep3d)        :: freq_reg_s
  type(sep3d)        :: time_reg_s
  character(len=1024):: temp1,temp2,temp3,temp4,temp5
  real, pointer :: locs(:,:)
  logical           :: verb
  integer           :: n(5)
  real              :: o(5),d(5)


  call sep_init()
  call init_3d()
  call sep_begin_prog()
  !---------------------------------------------
  !
  !                INITIALIZE INPUT
  !
  !---------------------------------------------

  call init_sep3d("in",time_irreg_s,"INPUT")
  call from_param("verb",verb,.false.)

  n(1)=time_irreg_s%n(1)
  o(1)=time_irreg_s%o(1)
  d(1)=time_irreg_s%d(1)
  n(2:5)=time_irreg_s%n(3:6)
  o(2:5)=time_irreg_s%o(3:6)
  d(2:5)=time_irreg_s%d(3:6)
  call init_sep3d(time_reg_s,"OUTPUT","FLOAT","REGULAR",n,o,d)

  


  !---------------------------------------------
  !
  !                INIITIALIZE FUNCTIONS
  !
  !---------------------------------------------

  if(.not. time_to_freq_init(time_irreg_s,time_irreg_s, "vel", freq_irreg_s,headers_s,.true.)) &
    call seperr("trouble initializing conversion to frequency")

  if(.not. init_transp_data()) &
    call seperr("trouble initializing transp data")

  if(.not. amo_zero_init(time_reg_s,freq_irreg_s,freq_reg_s,.false.))&
    call seperr("trouble initializing conversion to zero")

  if( .not. freq_to_time_init("vel",freq_reg_s,time_reg_s,& 
   time_irreg_s%n(1),time_irreg_s%o(1),time_irreg_s%d(1),.false.,.false.))&
    call seperr("trouble initializing conversion to time")

  !---------------------------------------------
  !
  !                WRITE OUTPUT
  !
  !---------------------------------------------
  call sep3d_write_description("out",time_reg_s)


  
  !---------------------------------------------
  !
  !                CREATE TEMP FILES
  !
  !---------------------------------------------

  !initialize temp file
  call from_history("in",temp1)
  call parcat(temp1,923)
  call auxinout(temp1)

  call from_history("in",temp2)
  call parcat(temp2,924)
  call auxinout(temp2)

!
  !---------------------------------------------
  !
  !                DOIT
  !
  !---------------------------------------------
  call to_transp_freq("in",temp1,locs,verb)
  call sseek(temp1,0,0)

  call transp_data_c(freq_irreg_s%n(2),freq_irreg_s%n(1),temp1,temp2,verb)
  call sseek(temp2,0,0)
  call sseek(temp1,0,0)

  call amo_transform_to_zero(temp2,temp1,locs,verb)
  call sseek(temp1,0,0)
  call sseek(temp2,0,0)

  call transp_data_c(product(freq_reg_s%n(1:4)),freq_reg_s%n(5),temp1,temp2,verb)
  call sseek(temp2,0,0)
  call from_transp_freq(temp2,"out",verb)

  !---------------------------------------------
  !
  !                CLEAN UP
  !
  !---------------------------------------------
!  call aux_unlink(temp2)
!  call aux_unlink(temp1)
  call sep_end_prog()
end program
