#!/usr/bin/env python
import SEP.opt_prog
import amo_inverse
import SEP.args
import amo_inv_flow
import amo_order

SEP.util.debug=1
prefixes={} ; order=[] ;  flow=[]

#MAIN PARAMETERS
main_args   =  amo_inv_flow.amo_inverse_eps0("AMO.main")     
flow.append(main_args) ;order.append("AMO.main")

#PARALLEL PARAMTERS
par =SEP.pj_func.parameters("AMO.PAR")         #get the parameters for parallel processing
flow.append(par) ;order.append("AMO.PAR")  ; prefixes["AMO.PAR"] = "par_"

#SORT THE DATA
sort=amo_inv_flow.amo_sort(main_args,"AMO.SORT")
flow.append(sort) ;order.append("AMO.SORT")  ; prefixes["AMO.SORT"] = "sort_"


#TRANSFORM TO FREQUENCY
freq=amo_inv_flow.to_freq(main_args,par,"AMO.TO_FREQ")  #transform to frequency
flow.append(freq) ;order.append("AMO.TO_FREQ");  prefixes["AMO.TO_FREQ"]="tf_"

#REORDER THE DATA ON THE NODES
reorder=amo_order.reorder(main_args,par,"AMO.ORDER")
flow.append(reorder) ;order.append("AMO.ORDER");


approx=amo_inv_flow.approx(main_args,par,"AMO.APPROX")
order.append("AMO.APPROX"); prefixes[par,"AMO.APPROX"] = "approx_"
flow.append(approx)

#TAKE A SUBSET
window=amo_inv_flow.window(main_args,par,"AMO.WINDOW")
flow.append(window);order.append("AMO.WINDOW"); prefixes["AMO.WINDOW"] = "tw_"


#TRANSFORM TO TIME
time=amo_inv_flow.to_time(main_args,par,"AMO.TO_TIME")  #transform to time
flow.append(time) ;order.append("AMO.TO_TIME");  prefixes["AMO.TO_TIME"]="tt_"



                                                                                                                
program=SEP.prog.prog("AMO_approx - Regularizing",
   "AMO_approx  ",par_blocks=flow,prefixes=prefixes , 
    restartable=1, order=order) 

program.get_options(delete=1)
program.prep_run(main_args.param("restart"))
