program stretch_fft_it
  use sep
  use sep3d_struct_mod
  use amo_wrap_mod
  integer ::  n1,n(3),ntraces,nf,ndone,nblock,maxsize
  logical :: inverse
  real    :: o1,d1,tot
  complex, allocatable :: cmpxcube(:,:),temp(:,:)
  real, allocatable :: realcube(:,:)
  type(sep3d) :: time_s,freq_s,t_s,f_s
  character(len=128) :: tp

  call sep_init()
  call sep_begin_prog()
  

  call init_sep3d("in",freq_s,"INPUT")
  ntraces=product(freq_s%n(1:4))
  call from_param("at__n",n1)
  call from_param("at__o",o1)
  call from_param("at__d",d1)
  ntraces=freq_s%ntraces
  
   
  call init_sep3d(freq_s,time_s,"OUTPUT")
  time_s%data_format="FLOAT"

  time_s%n(2:5)=freq_s%n(1:4)
  time_s%o(2:5)=freq_s%o(1:4)
  time_s%d(2:5)=freq_s%d(1:4)
  time_s%label(2:5)=freq_s%label(1:4)
  time_s%unit(2:5)=freq_s%unit(1:4)
  time_s%n(1)=n1
  time_s%o(1)=o1
  time_s%d(1)=d1

  call sep3d_set_sep3d(time_s)
  call amo_get_n1_size(time_s,nf,tp)
  call sep3d_write_description("out",time_s)


  ndone=0
  call from_param("maxsize",maxsize,1000)
  tot=maxsize*1000.*1000./real(nf*16.+n1*4.)
  maxsize=tot
  allocate(realcube(time_s%n(1),nblock),cmpxcube(nf,nblock),temp(nblock,nf))
  do while (ndone < ntraces)
    nblock=min(maxsize,ntraces-ndone)
      call sreed_window("in",2,(/ntraces,nf/),(/nblock,nf/),(/0,0/),(/1,1/),&
        8,temp)
      cmpxcube=transpose(temp)
      call unstretch_fft(nblock,realcube,cmpxcube)
      if(.not. amo_transform_from_mspace(nblock,realcube,cmpxcube)) &
         call seperr("trouble stretching")
      call srite_window("out",2,(/n1,ntraces/),(/n1,nblock/),(/0,0/),(/1,1/),&
        4,realcube)
    ndone=ndone+nblock
  end do
  deallocate(realcube,cmpxcube,temp)

end program
