program amo_interpit
  use  sep
  use amo_interp_mod
  use verb_mod
  implicit none
  integer :: n1,nd,n52,nh,i,n(5)
  real, allocatable :: head2(:,:)
  real, allocatable :: headers(:,:)
  complex, allocatable :: model(:,:,:,:,:),data(:,:)
  integer :: ifreq
  integer,external :: sreed
  logical :: adj,add,verb
  real :: o(5),d(5)
  character(len=128) :: label


  call sep_init()
  call getch_add_string("head=/dev/null") !no stdin header redirect to /dev/null  call getch_add_string("noheader=y")  ! repettive??? I just always use it
  call set_no_putch()
  call sep_begin_prog()
  call auxinout("model")
  call auxinout("data")
  call from_param("add",add,.false.)
  call from_param("adj",adj,.false.)

  call from_aux("headers","n1",n1)
  call from_aux("headers","n2",nh)
  
  if(n1/=4) call seperr("expecting n1 of headers to be 4")
  allocate(headers(n1,nh))
  if(4*size(headers)/=sreed("headers",headers,size(headers)*4)) &
    call seperr("trouble reading in headers")

  allocate(head2(5,nh))


  do i =1,5
    call sep_get_data_axis_par("model",i,n(i),o(i),d(i),label)
  end do


  do i=1,size(headers,2)
    head2(1,i)=(headers(1,i)-o(1))/d(1)+1.
    head2(2,i)=(headers(2,i)-o(2))/d(2)+1.
    head2(3,i)=(headers(3,i)-o(3))/d(3)+1.
    head2(4,i)=(headers(4,i)-o(4))/d(4)+1.
    head2(5,i)=(-headers(4,i)-o(4))/d(4)+1.
  end do

  call from_aux("data","n1",nd)
  call from_aux("data","n2",n52)

  if(n52 /= n(5)) call seperr("expecting n2 of data and n5 of model to be the same")
  if(nd /= nh) call seperr("expecting number of headers and data to be the same")

  allocate(model(n(1),n(2),n(3),n(4),1),data(nd,1))
  call from_param("verb",verb,.false.)

  if(.not.init_print_progress(0,n(5),verb)) &
    call seperr("trouble initialzing verbosity")

  do ifreq=1,n(5)
    call print_progress("Interpolating")

    if(adj .or. add) then
      if(8*size(data)/=sreed("data",data,size(data)*8)) &
        call seperr("trouble reading in the data")
    else
      data=cmplx(0.,0.)
    end if
      
    if(.not. adj .or. add) then
      if(8*size(model)/=sreed("model",model,size(model)*8)) &
        call seperr("trouble reading in the model")
    else
      model=cmplx(0.,0.)
    end if
    call amo_interp(adj,.true.,model,data,head2)
    if(.not. adj) then 
      if(add) call sseek_block("data",8,-size(data),1)
      call srite("data",data,size(data)*8)
    else
      if(add) call sseek_block("model",8,-size(model),1)
      call srite("model",model,size(model)*8)
    end if

  end do
write(0,*) "LEAVING"
  call sep_end_prog()
end program
