program amo_adj_exec
  use sep
  use amo_time_freq_mod
  use amo_inv_mod
  use sep3d_struct_mod
  use transp_data_mod
  implicit none
  type(sep3d)        :: time_irreg_s 
  type(sep3d)        :: time_pad_s 
  type(sep3d)        :: freq_irreg_s 
  type(sep3d)        :: headers_s 
  type(sep3d)        :: freq_out_s
  type(sep3d)        :: freq_reg_s
  type(sep3d)        :: time_reg_s
  type(sep3d)        :: time_out_s
  character(len=128):: temp1,temp2,temp3,temp4,temp5
  real, pointer :: locs(:,:)
  logical           :: verb
  integer           :: n(5)
  real              :: o(5),d(5)
  logical           :: pad3,pad2
  complex,allocatable :: buf(:,:)
  integer ::i3,i4,i5,i

write(0,*) "AAA 1"

  call sep_init()
write(0,*) "1AA 1"
  call init_3d()
write(0,*) "2AA 1"
  call sep_begin_prog()
write(0,*) "3AA 1"
  !---------------------------------------------
  !
  !                INITIALIZE INPUT
  !
  !---------------------------------------------
write(0,*) "AAA 2"

  call init_sep3d("in",time_irreg_s,"INPUT")
  call from_param("verb",verb,.false.)
  call init_sep3d(time_irreg_s,time_pad_s,"SCRATCH")
  call from_history("in",temp1)
  call set_oc_base(temp1)
write(0,*) "AAA 3"

  pad2=.false.
  pad3=.false.
  if( mod(time_pad_s%n(2),2) ==1) then
     time_pad_s%n(2)=time_pad_s%n(2)+1
     pad2=.true.
  end if
  if( mod(time_pad_s%n(3),2) ==1) then
     pad3=.true.
    time_pad_s%n(3)=time_pad_s%n(3)+1
  end if
  call sep3d_set_sep3d(time_pad_s)


  n(1)=time_pad_s%n(1)
  o(1)=time_pad_s%o(1)
  d(1)=time_pad_s%d(1)
  n(2:5)=time_pad_s%n(3:6)
  o(2:5)=time_pad_s%o(3:6)
  d(2:5)=time_pad_s%d(3:6)
  call init_sep3d(time_reg_s,"OUTPUT","FLOAT","REGULAR",n,o,d)

  


  !---------------------------------------------
  !
  !                INIITIALIZE FUNCTIONS
  !
  !---------------------------------------------

  if(.not. time_to_freq_init(time_irreg_s, time_pad_s,"vel", freq_irreg_s,headers_s,.true.)) &
    call seperr("trouble initializing conversion to frequency")

  if(.not. init_transp_data()) &
    call seperr("trouble initializing transp data")

  !if(.not. amo_zero_init(time_reg_s,freq_irreg_s,freq_reg_s,.false.))&
  !  call seperr("trouble initializing conversion to zero")

  if(.not. amo_inv_init(time_reg_s,freq_irreg_s,freq_reg_s,.false.))&
    call seperr("trouble initializing conversion to zero")

  !---------------------------------------------
  !
  !                WRITE OUTPUT
  !
  !---------------------------------------------
  call init_sep3d(freq_reg_s,freq_out_s,"OUTPUT")
  call init_sep3d(time_reg_s,time_out_s,"OUTPUT")
  if(pad2) time_out_s%n(2)=time_out_s%n(2)-1
  if(pad3) time_out_s%n(3)=time_out_s%n(3)-1
  freq_out_s%n(4)=1
  freq_out_s%o(4)=0.
  time_out_s%n(5)=1
  time_out_s%o(5)=0.
  call sep3d_set_sep3d(time_out_s)
  call sep3d_set_sep3d(freq_out_s)
  call sep3d_write_description("out",time_out_s)

  if( .not. freq_to_time_init("vel",freq_out_s,time_out_s,& 
   time_irreg_s%n(1),time_irreg_s%o(1),time_irreg_s%d(1),.false.,.false.))&
    call seperr("trouble initializing conversion to time")


  
  !---------------------------------------------
  !
  !                CREATE TEMP FILES
  !
  !---------------------------------------------

  !initialize temp file
  call from_history("in",temp1)
  call parcat(temp1,923)
  call auxinout(temp1)

  call from_history("in",temp2)
  call parcat(temp2,924)
  call auxinout(temp2)

!
  !---------------------------------------------
  !
  !                DOIT
  !
  !---------------------------------------------
  call to_transp_freq("in",temp1,locs,verb)
  call sseek(temp1,0,0)


  call transp_data_c(freq_irreg_s%n(2),freq_irreg_s%n(1),temp1,temp2,verb)
  call sseek(temp2,0,0)
  call sseek(temp1,0,0)
  !create model
  allocate(buf(freq_reg_s%n(1),freq_reg_s%n(2)))
  buf=0.
  call sep_put_data_axis_par(temp2,1,freq_irreg_s%n(1),0.,1.,"none")
  call sep_put_data_axis_par(temp2,2,freq_irreg_s%n(2),0.,1.,"none")
  call sep_put_data_axis_par(temp1,1,freq_reg_s%n(1),0.,1.,"none")
  call sep_put_data_axis_par(temp1,2,freq_reg_s%n(2),0.,1.,"none")
  call sep_put_data_axis_par(temp1,3,freq_reg_s%n(3),0.,1.,"none")
  call sep_put_data_axis_par(temp1,4,freq_reg_s%n(4),0.,1.,"none")
  call sep_put_data_axis_par(temp1,5,freq_reg_s%n(5),0.,1.,"none")
  call auxputch("esize","d",8,temp1)
  call auxputch("esize","d",8,temp2)
  call auxclose(temp1)
  call auxclose(temp2)
  call auxinout(temp1)
  call auxinout(temp2)
  do i5=1,freq_reg_s%n(5)
    do i4=1,freq_reg_s%n(4)
      do i3=1,freq_reg_s%n(3)
        call  srite(temp1,buf,size(buf)*8)
      end do
    end do
  end do
  call sseek(temp1,0,0)
  deallocate(buf)

!  i3=smooth_interp_op(.true.,.false.,temp1,temp2)


  call amo_inv(temp2,temp1,locs,verb)
  call sseek(temp1,0,0)
  call sseek(temp2,0,0)


 call amo_reg_to_zero(temp1,temp2,verb)
  !1-->2
 call sseek(temp1,0,0)
 call sseek(temp2,0,0)
write(0,*) "CHECK THIS",freq_reg_s%n


  call transp_data_c(product(freq_out_s%n(1:4)),freq_reg_s%n(5),temp2,temp1,verb)
write(0,*) "GETTING STUCK"
  call sseek(temp1,0,0)
  call from_transp_freq(temp1,"out",verb,pad2,pad3)

  !---------------------------------------------
  !
  !                CLEAN UP
  !
  !---------------------------------------------
  call aux_unlink(temp2)
  call aux_unlink(temp1)
  call sep_end_prog()
end program
