program amo_ireg_freq
  use sep
  use sep3d_struct_mod
  use amo_wrap_mod
  integer ::  n1,n(3),ntraces,nf,ndone,nblock,maxsize,nh
  logical :: inverse
  real    :: o1,d1,tot
  type(sep3d) :: time_s,freq_s,t_s
  real, allocatable :: realcube(:,:),headers(:,:),key(:)
  complex, allocatable :: cmpxcube(:,:),temp(:,:)
  character(len=127) :: key1,key2,key3,key4

  call sep_init()
  call sep_begin_prog()
  

  call init_sep3d("in",time_s,"INPUT")

  call amo_get_n1_size(time_s,nf,key1)
  call init_sep3d(freq_s,"OUTPUT","COMPLEX","REGULAR",&
    (/freq_s%ntraces,nf/))
  call sep3d_write_description("out",freq_s)

  call init_sep3d(time_s,t_s,"SCRATCH")
  call axis_allocate(t_s,2)
  t_s%n=(/time_s%n(1),time_s%ntraces/)
  t_s%o=(/time_s%o(1),0./)
  t_s%d=(/time_s%d(1),1./)
  
  ndone=0
  call from_param("maxsize",maxsize,1000)
  tot=maxsize*1000.*1000./real(nf*16.+n1*4.)
  maxsize=tot
  allocate(realcube(time_s%n(1),nblock),cmpxcube(nf,nblock),temp(nblock,nf))
  allocate(headers(4,nblock),key(nblock))

  call to_history("n1",4)
  call to_history("n2",t_s%n(2))

  call from_param("mx_key",key1,"cmp_x")
  call from_param("my_key",key2,"cmp_y")
  call from_param("hx_key",key3,"h_x")
  call from_param("hy_key",key4,"h_y")

  do while (ndone < ntraces)
    nblock=min(maxsize,ntraces-ndone)

    call sep3d_grab_headers("in",t_s,nh,nwind=(/nblock/),fwind=(/ndone/))

    call sep3d_grab_key_vals(t_s,trim(key1),key); 
    headers(1,:)=(key-time_s%o(3))/time_s%d(3)+1.
    call sep3d_grab_key_vals(t_s,trim(key2),key); 
    headers(2,:)=(key-time_s%o(4))/time_s%d(4)+1.
    call sep3d_grab_key_vals(t_s,trim(key3),key); 
    headers(3,:)=(key-time_s%o(5))/time_s%d(5)+1.
    call sep3d_grab_key_vals(t_s,trim(key4),key); 
    headers(4,:)=(key-time_s%o(6))/time_s%d(6)+1.

    if(.not. sep3d_read_data("in",t_s,realcube)) &
      call seperr("trouble reading data")

    if(.not. amo_transform_to_mspace(nblock,realcube,cmpxcube)) &
         call seperr("trouble stretching")

    temp=transpose(cmpxcube)

    call srite_window("headers",2,(/4,ntraces/),(/4,nblock/),(/0,ndone/),&
      (/1,1/), 4,headers)

    call srite_window("out",2,(/ntraces,nf/),(/nblock,nf/),(/ndone,0/),(/1,1/),&
      8,temp)

    ndone=ndone+nblock

  end do
  deallocate(realcube,cmpxcube,temp)

end program
