program amo_adj_exec
  use sep
  use amo_time_freq_mod
  use sep3d_struct_mod
  use transp_data_mod
  type(sep3d) :: input_s,freq_irreg_s,reg_s,freq_reg,headers_s
  character(len=1024):: temp1,temp2
  real, pointer :: locs(:,:)
  logical           :: verb


  call sep_init()
  call init_3d()
  call sep_begin_prog()
  !---------------------------------------------
  !
  !                INITIALIZE INPUT
  !
  !---------------------------------------------

  call init_sep3d("in",input_s,"INPUT")
  call from_param("verb",verb,.false.)

  


  !---------------------------------------------
  !
  !                INIITIALIZE FUNCTIONS
  !
  !---------------------------------------------

  if(.not. time_to_freq_init(input_s,input_s, "vel", freq_irreg_s,headers_s,.false.)) &
    call seperr("trouble initializing conversion to frequency")


  if(.not. init_transp_data()) &
    call seperr("trouble initializing transp data")

  !---------------------------------------------
  !
  !                WRITE OUTPUT
  !
  !---------------------------------------------
  call sep3d_write_description("out",freq_irreg_s)
  call sep3d_write_description("headers",headers_s)


  
  !---------------------------------------------
  !
  !                CREATE TEMP FILES
  !
  !---------------------------------------------

  !initialize temp file
  call from_history("in",temp1)
  call parcat(temp1,923)
  call auxinout(temp1)

  !---------------------------------------------
  !
  !                DOIT
  !
  !---------------------------------------------
  call to_transp_freq("in",temp1,locs,verb)
  call sseek(temp1,0,0)
  call transp_data_c(freq_irreg_s%n(2),freq_irreg_s%n(1),temp1,"out",verb)
  call srite("headers",locs,size(locs)*4)

  !---------------------------------------------
  !
  !                CLEAN UP
  !
  !---------------------------------------------
  call aux_unlink(temp1)
  call sep_end_prog()
end program
