program smooth_it
  use sep
  use verb_mod
  use sep3d_struct_mod
  use amo_wrap_mod
  use polydiv_func_mod
  implicit none
  type(sep3d) :: d_s,m_s,reg_s,input_s
  logical :: adj,add,verb
  complex, allocatable :: model(:,:,:),data(:,:,:),temp(:,:)
  integer :: n(5),nf,ifreq,nfreq,i,ierr
  real  :: o(5),d(5),hx(2),hy(2)
  type(filter) :: filt

  call sep_init()  !hook up parameters
  call getch_add_string("head=/dev/null") !no stdin header redirect to /dev/null
  call getch_add_string("noheader=y")  ! repettive??? I just always use it
  call set_no_putch()
  call from_param("amx_n",n(2))
  call from_param("amx_o",o(2))
  call from_param("amx_d",d(2))
                                                                                
  call from_param("amy_n",n(3))
  call from_param("amy_o",o(3))
  call from_param("amy_d",d(3))
                                                                                
  call from_param("ahx_n",n(4))
  call from_param("ahx_o",o(4))
  call from_param("ahx_d",d(4))
                                                                                
  call from_param("ahy_n",n(5))
  call from_param("ahy_o",o(5))
  call from_param("ahy_d",d(5))
                                                                                
  call from_param("at__n",n(1))
  call from_param("at__o",o(1),0.)
  call from_param("at__d",d(1))

  call init_sep3d(input_s,"SCRATCH","FLOAT","REGULAR",n,o,d)


  call auxinout("model")
  call auxinout("data")

  call from_param("add",add,.false.)
  call from_param("adj",adj,.false.)
  call amo_get_n1_size(input_s,nf,.true.,0)




  call allocatehelix(filt,4)
  filt%lag=(/1,input_s%n(4)-2,input_s%n(4)-1,input_s%n(4)/)
  filt%flt=(/-.42,-.06,-.13,-.38/)

  call from_aux("model","n5",nfreq)
  call from_param("verb",verb)


  call polydiv_func_init(n(2),n(3),n(4)*n(5),filt)

  if(.not.init_print_progress(0,nfreq*n(5)*n(4)*3,verb)) &
    call seperr("trouble initialzing verbosity")

  allocate(model(n(2),n(3),n(4)*n(5)),data(n(2),n(3),n(4)*n(5)))
  allocate(temp(n(2),n(3)))
  do ifreq=1,nfreq
    !read it in
    if( add .or. .not. adj) then
      call sreed("model",model,8*size(model))
      if(adj) call sseek("model",-size(model)*8,1)
    else
      model=0.
    end if
    if( add .or.       adj) then
       call sreed("data",data,size(data)*8)
       if(.not. adj) call sseek("data",-size(data)*8,1)
    else
      data=0.
    end if

   !transform to kx,ky
   do i=1,n(4)*n(5)
     call print_progress("transform to kx ky")
     if(add .or. .not. adj) then
       temp=model(:,:,i)
       call amo_hx_transform(hx,hy,temp,.true.,.false.,.false.,.false.)
       model(:,:,i)=temp
     end if
     if(.not. add .or. .not. adj) then
       temp=data(:,:,i)
       call amo_hx_transform(hx,hy,temp,.true.,.false.,.false.,.false.)
       data(:,:,i)=temp
     end if
   end do

   !smooth
   call polydiv_func_lop2(adj,model,data)

   !transfer back to mx,my
   do i=1,n(4)*n(5)
     call print_progress("transform to mx my")
     if(add .or. .not. adj) then
       temp=model(:,:,i)
       call amo_hx_transform(hx,hy,temp,.false.,.true.,.false.,.false.)
       model(:,:,i)=temp
     end if
     if(.not. add .or. .not. adj) then
       temp=data(:,:,i)
       call amo_hx_transform(hx,hy,temp,.false.,.true.,.false.,.false.)
       data(:,:,i)=temp
     end if
   end do

    if(.not. adj) call srite("data",data,size(data)*8)
    if(      adj) call srite("model",model,size(model)*8)
  end do
  call sep_end_prog()
end program
