      program amo_adj_exec
  use sep
  use amo_time_freq_mod
  use sep3d_struct_mod
  use transp_data_mod
  implicit none
  type(sep3d) :: input_s,freq_irreg_s,reg_s,freq_reg,headers_s
  character(len=1024):: temp1,temp2
  real, pointer :: locs(:,:)
  logical           :: verb
  integer           :: nt
  real              :: ot,dt

  call sep_init(SOURCE)

  call sep_begin_prog()
  !---------------------------------------------
  !
  !                INITIALIZE INPUT
  !
  !---------------------------------------------

  call init_sep3d("in",freq_reg,"INPUT")
  call from_param("verb",verb,.false.)

  


  !---------------------------------------------
  !
  !                INIITIALIZE FUNCTIONS
  !
  !---------------------------------------------

  if(.not. init_transp_data()) &
    call seperr("trouble initializing transp data")

  call from_param("at__n",nt)
  call from_param("at__o",ot,0.)
  call from_param("at__d",dt)
  if( .not. freq_to_time_init("vel",freq_reg,reg_s,nt,ot,dt,.true.,.true.))&
    call seperr("trouble initializing conversion to time")


  !---------------------------------------------
  !
  !                WRITE OUTPUT
  !
  !---------------------------------------------
  call sep3d_write_description("out",reg_s)

  
  !---------------------------------------------
  !
  !                CREATE TEMP FILES
  !
  !---------------------------------------------

  !initialize temp file
  call from_history("in",temp1)
  call parcat(temp1,923)
  call auxinout(temp1)

  !---------------------------------------------
  !
  !                DOIT
  !
  !---------------------------------------------
  call transp_data_c(product(freq_reg%n(1:4)),freq_reg%n(5),"in",temp1,verb)
  call sseek(temp1,0,0)
  call from_transp_freq(temp1,"out",verb)

  !---------------------------------------------
  !
  !                CLEAN UP
  !
  !---------------------------------------------
  call aux_unlink(temp1)
  call sep_end_prog()
end program
