program smooth_it
  use sep
  use sep3d_struct_mod
  use amo_wrap_mod
  use polydiv_func_mod
  use verb_mod
  implicit none
  type(sep3d) :: d_s,m_s,reg_s,input_s
  logical :: adj,add,verb
  complex, allocatable :: model(:,:,:),data(:,:,:),temp(:,:)
  integer :: n(5),nf,ifreq,nfreq,i,ierr,i4,i5
  real  :: o(5),d(5),hx(2),hy(2)
  type(filter) :: filt

  call sep_init()  !hook up parameters
  call init_sep3d("in",d_s,"INPUT")
  n(2:5)=d_s%n(1:4)
  o(2:5)=d_s%o(1:4)
  d(2:5)=d_s%d(1:4)
  call from_param("at__n",n(1))
  call from_param("at__o",o(1),0.)
  call from_param("at__d",d(1))
  call init_sep3d(input_s,"SCRATCH","FLOAT","REGULAR",n,o,d)
  call sep_put_data_axis_par("out",4,1,0.,d(5),"h_y")


  call amo_get_n1_size(input_s,nf,.true.,0)
  nfreq=d_s%n(5)
  call from_param("verb",verb)


  if(.not.init_print_progress(0,nfreq*((n(5)*2+1)*n(4)),verb)) &
    call seperr("trouble initialzing verbosity")

  allocate(model(n(2),n(3),n(4)),data(n(2),n(3),n(4)*n(5)))
  allocate(temp(n(2),n(3)))
  do ifreq=1,nfreq
    !read it in
    model=0 
    call sreed("in",data,size(data)*8)

   !transform to kx,ky
   do i=1,n(4)*n(5)
     call print_progress("transform to kx ky")
     temp=data(:,:,i)
     call amo_hx_transform(hx,hy,temp,.true.,.false.,.false.,.false.)
     data(:,:,i)=temp
   end do
   !transfer back to mx,my
   hy(2)=0
   i=0
   do i5=1,n(5)
     hy(1)=(i5-1)*d(5)+o(5)
     do i4=1,n(4)
       i=i+1
       hx=(i4-1)*d(4)+o(4)
       temp=data(:,:,i)
       call print_progress("transform to hy=0")
       call amo_hx_transform(hx,hy,temp,.false.,.false.,.true.,.false.)
       model(:,:,i4)=model(:,:,i4)+temp
     end do
   end do
   do i4=1,n(4)
     call print_progress("transform to space")
     temp=model(:,:,i4)
     call amo_hx_transform(hx,hy,temp,.false.,.true.,.false.,.false.)
     model(:,:,i4)=temp
   end do
   call srite("out",model,size(model)*8)
  end do
  call sep_end_prog()
end program
