import SEP.sepfile
import SEP.util
import SEP.spawn
import types,math
import string
import SEP.pj_func
import SEP.pj_split
import SEP.pf_copy
import SEP.pf_irreg
import SEP.pf_split
import SEP.paths
__author__ = "Robert G. Clapp"
__email__ = "bob@sep.stanford.edu"
__version = "2005.04.14"


class approx(SEP.pj_split.par_job):
  def __init__(self,name="AMO_to_zero"):
    """Initialize the AMO  program"""
    SEP.pj_split.par_job.__init__(self,name)
    self.add_param("program","AMO_approx.x")
 
  def add_doc_params(self):
    """Parameters for AMO_to_freq"""
    SEP.pj_split.par_job.add_doc_params(self)

    self.add_doc_param("stdin",doc="Input file")
    self.add_doc_param("stdout",doc="Output file")
    self.add_doc_param("f_max",60.,doc="Maximum frequency")
    self.add_doc_param("t_min_log",.2,doc="Minimum time for logstrech")
    self.add_doc_param("verb","y",doc="Whether or not to be verbose")
    self.add_doc_param("eps",.000001,"Epsilon for normalization calculation")
    self.param_list=["verb","t_min_log","f_max","eps"]
    for ax in ["mx","my","hx","hy","t_"]:
      self.add_doc_param("a%s_n"%ax,doc="Number of samples in %s"%ax)
      self.add_doc_param("a%s_o"%ax,doc="First sample in %s"%ax)
      self.add_doc_param("a%s_d"%ax,doc="Sampling in %s"%ax)
      self.param_list.extend(["a%s_n"%ax,"a%s_o"%ax,"a%s_d"%ax])
    self.delete_object_par_params()


  def prep_run(self,restart=None):  
    """Check to make sure the parameters make sense"""


    aa=SEP.stat_sep.status("%s.stat"%self.param("mapping_file",error=1),load=1)
    aa.restart(1)
    self.map=aa.get_stat_elem(1)
                                                                                
                                                                                
    #get the section parameters
    nblock=len(self.map.keys())
    sect_pars=SEP.pj_func.simple_parameter_list(nblock)


    #get the section parameters

    self.add_param("pverb",self.param("verb") )
    self.par_files={}

    self.par_files["intag"]=SEP.pv_always_split.cmplx_vector(name=self.param("stdin"),
     usage="INPUT",remove=None,tag="<",load=1,exists=1)

    if restart:
      self.par_files["outtag"]=self.par_files["intag"].clone(
        name=self.param("stdout"), tag=">",usage="OUTPUT")
    else:
      self.par_files["outtag"]=self.par_files["intag"].clone(name=self.param("stdout"),
     usage="OUTPUT",remove=None,tag=">",space_only=1)
      self.par_files["outtag"].zero()

    self.par_files["headers"]=SEP.pf_copy.parfile(name=self.param("headers"),
      tag="headers=",usage="INPUT",njobs=nblock,
      nblock=nblock)


    self.add_param("files",self.par_files)
    self.add_param("assign_map",self.par_files["intag"].get_stat_elem(1))
    self.add_param("sect_pars",sect_pars)
    self.add_param("global_pars",self.return_set_params(self.param_list))
    SEP.pj_split.par_job.prep_run(self,restart)
