module amo_approx_mod
use amo_wrap_mod
use sep3d_struct_mod
use polydiv_func_mod
use amo_interp_mod
type(filter),private, save :: filt
real, pointer, save,private :: head2(:,:)
integer, private, save ::nf,n(5)
complex, allocatable ,private :: temp(:,:)

contains

subroutine amo_approx_init(struct,n_f,headers)
integer :: n_f
type(sep3d)  :: struct
real, pointer :: headers(:,:)


  nf=n_f
  !INIT OPERATORS
  head2=>headers
  write(0,*) "HEAD RANGE",sum(head2)
  call amo_get_n1_size(struct,nf,.true.,0)
  call allocatehelix(filt,4)
  filt%lag=(/1,struct%n(4)-2,struct%n(4)-1,struct%n(4)/)
  filt%flt=(/-.42,-.06,-.13,-.38/)
  n=struct%n
  allocate(temp(struct%n(2),struct%n(3)))
end subroutine

subroutine  prec(adj,pvar,mod)
logical :: adj
complex :: pvar(:,:,:),mod(:,:,:)

call polydiv_func_init(n(3),n(2),n(5)*n(4),filt)
call polydiv_func_lop2(adj,pvar,mod)
call polydiv_func_close()

end subroutine


subroutine op(adj,mod3,dat2)
logical :: adj
complex :: mod3(:,:,:),dat2(:,:)
complex ,allocatable:: model(:,:,:,:,:)

allocate(model(n(2),n(3),n(4),n(5),1))
call transform_3_5(mod3,model)
write(0,*) "TRANAFORM",sum(mod3),sum(model),adj
call amo_interp(adj,.false.,model,dat2,head2)
write(0,*) "TRANSFORM",sum(dat2),sum(model)
call transform_5_3(model,mod3)
write(0,*) "TRAN3FORM",sum(mod3),sum(model)
deallocate(model)
end subroutine

subroutine to_k(mod)
complex :: mod(:,:,:)
integer :: i3
real :: hx(2),hy(2)

hx=0;hy(2)=0

do i3=1,size(mod,3)
  temp=mod(:,:,i3)
  call amo_hx_transform(hx,hy,temp,.true.,.false.,.false.,.false.)
  mod(:,:,i3)=temp
end do
end subroutine
subroutine to_x(mod)
complex :: mod(:,:,:)
integer :: i3
real :: hx(2),hy(2)

hx=0;hy(2)=0

do i3=1,size(mod,3)
  temp=mod(:,:,i3)
  call amo_hx_transform(hx,hy,temp,.false.,.true.,.false.,.false.)
  mod(:,:,i3)=temp
end do
end subroutine


subroutine transform_5_3(mod5,mod3)
  integer :: i1,i2,i3,i4,i
  complex :: mod3(:,:,:),mod5(:,:,:,:,:)

  i=0 
  do i4=1,size(mod5,4)
    do i3=1,size(mod5,3)
      i=i+1
      do i2=1,size(mod5,2)
        do i1=1,size(mod5,1)
          mod3(i1,i2,i)= mod5(i1,i2,i3,i4,1)
        end do
      end do
    end do
  end do
end subroutine

subroutine transform_3_5(mod3,mod5)
  integer :: i1,i2,i3,i4,i
  complex :: mod3(:,:,:),mod5(:,:,:,:,:)

  i=0 
  do i4=1,size(mod5,4)
    do i3=1,size(mod5,3)
      i=i+1
      do i2=1,size(mod5,2)
        do i1=1,size(mod5,1)
          mod5(i1,i2,i3,i4,1)=mod3(i1,i2,i)
        end do
      end do
    end do
  end do
end subroutine





end module
