import SEP.sepfile
import SEP.util
import SEP.spawn
import types,math
import string
import SEP.paths
import SEP.pf_copy
import SEP.pv_always_split
import SEP.op_oc_par_split
import SEP.pj_base
__author__ = "Robert G. Clapp"
__email__ = "bob@sep.stanford.edu"
__version = "2005.03.18"


class  op(SEP.op_oc_par_split.operator):
  def __init__(self,name="AMO_interp"):
    """Initialize the AMO  program"""
    SEP.op_oc_par_split.operator.__init__(self,name,msg="Smoothing")
 
  def add_doc_params(self):
    """Parameters for AMO_to_freq"""
    SEP.op_oc_par_split.operator.add_doc_params(self)


    self.add_doc_param("verb","y",doc="Whether or not to be verbose")
    self.add_doc_param("spread","y",doc="Whether or not the data is distributed on the nodes")

    self.param_list=["verb"]

    self.del_doc_param("adj_com")
    self.delete_object_par_params()


  def prep_run(self,restart=None):  
    """Check to make sure the parameters make sense"""

    restart=self.main.param("restart")


    #get the section parameters
    nblock=len(self.param("assign_map").keys())
    sect_pars=self.build_sect_params(nblock)
    self.add_param("program","AMO_interp.x")

    self.add_param("adj_com","adj=y")
    self.add_param("pverb",self.param("verb") )
    self.par_files={}

   
    if self.logic("spread"): 
      load=1
      remove=None
    else: 
     load=None
     remove=1

    self.par_files["range"]=self.param("range").clone(tag="data=",space_only=1)


#SEP.pv_always_split.cmplx_vector(name="interp.range", 
#      dff_axis=2, tag="data=",usage="INPUT",njobs=nblock, 
#     nblock=nblock,remove=remove,sect_map=self.map)

    self.par_files["domain"]=self.param("domain").clone(tag="model=",space_only=1)

#SEP.pv_always_split.cmplx_vector(name="interp.domain" , 
#        dff_axis=5, tag="model=",usage="OUTPUT",njobs=nblock,
#        nblock=nblock,collect_it=None,remove=remove,sect_map=self.map)

    self.par_files["headers"]=SEP.pf_copy.parfile(name=self.param("headers"), 
      tag="headers=",usage="INPUT",njobs=nblock,
      nblock=nblock)

    self.add_param("files",self.par_files)
    order=[]
    for i in range(nblock): order.append(str(i))
    self.add_param("order",order)
    self.add_param("sect_pars",sect_pars)


    self.add_param("global_pars",self.return_set_params(self.param_list))
    SEP.op_oc_par_split.operator.prep_run(self,restart=None)

    

  def build_sect_params(self,nblock):
    """Build parameters for parallel job"""
    sect_pars={}

    for i in range(nblock):
      sect_pars[str(i)]=SEP.args.basic(name=str(i))
    return sect_pars
