import SEP.pf_split
import SEP.pj_base
import SEP.pf_resplit


class reorder(SEP.pj_split.par_job):

  def __init__(self,main_par,par_par,nm="AMO.reorder"):
     self.main=main_par
     self.par_par=par_par
     SEP.pj_base.par_job.__init__(self,nm)
     self.delete_cl_par_params()
     

  
  


  def build_check_params(self):
    """Build commands for converting to stretching frequency"""
    self.set_cl_par_params(self.par_par.return_set_params())
    SEP.pj_base.par_job.build_check_params(self)

  def prep_run(self,restart=None):
    """We don't need to do anything"""
    self.setup_mach_rsh()
    key_mach={}
    key_sect={}
    self.mach.init_all()
    self.check_nodes()
    self.setup_communicator()
    machlabel=self.mach.free_mach() 
    fname=self.main.param("irregular")
    file_in=SEP.sepfile.sep_file("%s.stretch"%fname)
    nblock=int(self.main.param("nblock",int(file_in.axis(2)[0])))
    ito=0
    key_label={}
    for i in range(nblock):
      key_label[str(i)]=machlabel[ito]
      ito+=1
      if ito == len(machlabel): ito=0

    file_out=SEP.pf_split.parfile(name="%s.stretch"%fname,
      dff_axis=2, tag="<",usage="INPUT",njobs=nblock,
      restart=restart,nblock=nblock)

    tag=file_out.tags(key_label,SEP.log.logging.new_file_name("REORDER"))
    for key in file_out.return_keys(): file_out.done(key)
    file_out._unlock_it()

    

  def clean_files(self):
    """Don't need to clean anything"""
