
module amo_smooth_mod
  use polydiv_func_mod
  type(filter),private,save :: filt
  integer, private, save :: n(5)
contains


subroutine amo_smooth_init(n_m)
  integer :: n_m(5)
  n=n_m
  call allocatehelix(filt,4)
  filt%lag=(/1,n(4)-2,n(4)-1,n(4)/)
  filt%flt=(/-.42,-.06,-.13,-.38/)


end subroutine


integer function smooth_op(adj,add,mod_tag,dat_tag,op1,op2,op3,op4&
  &,op5,op6,op7,op8,op9)
  logical,            intent(in) :: adj,add
  character(len=128), intent(in) :: mod_tag,dat_tag
  integer,external,optional :: op1,op2,op3,op4,op5,op6,op7,op8,op9
  integer, external :: sreed_window,srite_window
  integer :: fw(5),nw(5),jw(5)
  integer :: nfreq,ifreq,i
  complex, allocatable :: mod(:,:,:),dat(:,:,:),temp(:,:)
  real :: hx(2),hy(2)

  smooth_op=0
  nfreq=n(5)
  fw=0
  nw=n
  jw=1
  nw(5)=1

  allocate(mod(n(1),n(2),n(3)*n(4)),dat(n(1),n(2),n(3)*n(4)))
  allocate(temp(n(1),n(2)))
  call polydiv_func_init(n(1),n(2),n(3)*n(4),filt)
  do ifreq=1,nfreq
    write(0,*) "1MOOTH",adj,ifreq,nfreq
    fw(5)=ifreq-1

    if(0/=sreed_window(dat_tag,5,n,nw,fw,jw,8,dat))&
      call seperr("trouble reading in mod")
    if(0/=sreed_window(mod_tag,5,n,nw,fw,jw,8,mod))&
      call seperr("trouble reading in mod")
    write(0,*) "2MOOTH",adj,ifreq,nfreq
    if(.not. add) then
      if(.not. adj)  dat=0.
      if(adj)  mod=0.
    end if

    !transform to kx,ky
    do i=1,n(4)*n(3)
      if(add .or. .not. adj) then
        temp=mod(:,:,i)
        call amo_hx_transform(hx,hy,temp,.true.,.false.,.false.,.false.)
        mod(:,:,i)=temp
      end if
      if(.not. add .or. .not. adj) then
        temp=dat(:,:,i)
        call amo_hx_transform(hx,hy,temp,.true.,.false.,.false.,.false.)
        dat(:,:,i)=temp
      end if
    end do


    !smooth
    call polydiv_func_lop2(adj,mod,dat)

    !transfer back to mx,my
    do i=1,n(4)*n(3)
      if(add .or. .not. adj) then
        temp=mod(:,:,i)
        call amo_hx_transform(hx,hy,temp,.false.,.true.,.false.,.false.)
        mod(:,:,i)=temp
      end if
      if(.not. add .or. .not. adj) then
        temp=dat(:,:,i)
        call amo_hx_transform(hx,hy,temp,.false.,.true.,.false.,.false.)
        dat(:,:,i)=temp
      end if
    end do
    write(0,*) "3MOOTH",adj,ifreq,nfreq
    if(0/=srite_window(dat_tag,5,n,nw,fw,jw,8,dat)) &
      call seperr("trouble reading in mod")
    if(0/=srite_window(mod_tag,5,n,nw,fw,jw,8,mod)) &
      call seperr("trouble reading in mod")
    write(0,*) "4MOOTH",adj,ifreq,nfreq
  end do
  call polydiv_func_close()
  call sseek(dat_tag,0,0)
  call sseek(mod_tag,0,0)
  deallocate(dat,mod,temp)

end function

end module
