module amo_zero_mod
  use sep3d_struct_mod
  use amo_wrap_mod
  use amo_interp_mod
  use sep
  use verb_mod
  use random
  implicit none
  real, private, save   :: hx_dist
  real, private,save    :: o(5),d(5)
  integer, private,save :: n(5),nf,nt
  type(sep3d),private,save           :: irreg_s,input_s,output_s
  real,private,save                  :: eps 
  logical,private,save               :: normalize
  

  contains
  logical function amo_zero_init(d_s,freq_i,freq_reg,init_amo)
    type(sep3d) :: d_s,freq_reg,freq_i
    integer :: nout(5),i,i_f
    real  :: oout(5),dout(5)
    logical :: init_amo
    amo_zero_init=.false.

    if(init_amo) call amo_get_n1_size(d_s,nf,.true.,0)
    irreg_s=freq_i
    nt=max(100,irreg_s%n(1))
    o=0;d=1;n(5)=irreg_s%n(2)
    n(1:4)=d_s%n(2:5)
    o(1:4)=d_s%o(2:5)
    d(1:4)=d_s%d(2:5)
    oout=o; dout=d; nout=n
    oout(4)=0.; nout(4)=1
    call from_param("ahx_n_o",nout(3),nout(3))
    call from_param("ahx_o_o",oout(3),oout(3))
    call from_param("ahx_d_o",dout(3),dout(3))
    call from_param("hx_dist",hx_dist,3*d(3))
    call init_sep3d(input_s,"OUTPUT","COMPLEX","REGULAR",n,o,d)
    call init_sep3d(freq_reg,"OUTPUT","COMPLEX","REGULAR",nout,oout,dout)
    output_s=freq_reg
    call from_param("normalize",normalize,.false.)
    call from_param("eps",eps,.00001)
    amo_zero_init=.true.
  end function

  subroutine amo_transform_to_zero(intag,outtag,locs,verb)
    character(len=*)    :: intag,outtag
    real                :: locs(:,:)
    real,allocatable    ::  headers(:,:),tref(:,:)
    complex,allocatable ::  model(:,:,:,:,:),data(:,:),ref(:,:,:,:,:),temp(:,:),out(:,:,:,:,:),fref(:,:)
    integer             :: ndone,nblock,iyb,ibeg,i
    logical             :: verb


    allocate(headers(5,size(locs,2)))
    do i=1,size(headers,2)
      headers(1,i)=(locs(1,i)-o(1))/d(1)+1.
      headers(2,i)=(locs(2,i)-o(2))/d(2)+1.
      headers(3,i)=(locs(3,i)-o(3))/d(3)+1.
      headers(4,i)=(locs(4,i)-o(4))/d(4)+1.
      headers(5,i)=(-locs(4,i)-o(4))/d(4)+1.
    end do

    iyb=nint(-output_s%o(4)/output_s%d(4)+1.)
    if(.not.init_print_progress(0,irreg_s%n(2),verb)) &
      call seperr("trouble initialzing verbosity")

   allocate(tref(nt,1))
   do i=1,size(tref)
     tref(i,1)=random_normal()
   end do
   allocate(fref(irreg_s%n(2),1))
   if(.not. amo_transform_to_mspace(1,tref,fref)) call seperr("trouble stretching")
                                                                                                

    allocate(model(n(1),n(2),n(3),n(4),1),data(irreg_s%n(1),1))
    allocate(ref(n(1),n(2),n(3),1,1),temp(n(1),N(2)))
    allocate(out(n(1),n(2),n(3),1,1))
    ibeg=0
    do i=1,irreg_s%n(2)
      call print_progress("transforming to zero")
      call sreed(intag,data,irreg_s%n(1)*8)
      model=0.
      call amo_interp(.true.,.false.,model,data,headers)
      call amo_to_zero(.true.,.false.,input_s,output_s,i+ibeg,hx_dist,out,model,temp)
      if(normalize .and. nt >0) then
        ref=1
        model=0
        call amo_to_zero(.false.,.false.,input_s,output_s,i+ibeg,hx_dist,ref,model,temp)
        data=0
        call amo_interp(.false.,.false.,model,data,headers)
        model=0
        call amo_interp(.true.,.false.,model,data,headers)
        ref=0
        call amo_to_zero(.true.,.false.,input_s,output_s,i+ibeg,hx_dist,ref,model,temp)
        out=out/(cabs(ref)+eps)
      end if
      call srite(outtag,out,product(output_s%n(1:3))*8)
!      call srite(outtag,ref,product(output_s%n(1:3))*8)
    end do
    deallocate(model,data,ref,temp,headers,out,tref,fref)
  end subroutine
end module
