module amo_interp_mod
use sep3d_struct_mod
real, pointer, save,private :: head(:,:)
integer, private,save :: n_m(5),n_d(2)

contains


  
subroutine interp_init(headers,nd,nm)
real, pointer :: headers(:,:)
integer ::  nd(:),nm(:)

n_d(1:2)=nd(1:2)
n_m(1:5)=nm(1:5)
head=>headers

end subroutine


  integer function interp_op(adj,add,mod_tag,dat_tag,op1,op2,op3,op4&
    &,op5,op6,op7,op8,op9)
    logical,            intent(in) :: adj,add
    character(len=128), intent(in) :: mod_tag,dat_tag
    integer,external,optional :: op1,op2,op3,op4,op5,op6,op7,op8,op9
    integer :: i5
    complex, allocatable :: mod(:,:,:,:,:),dat(:,:)
    integer, external :: sreed_window,srite_window
    integer :: nd(2),jd(2),fd(2),nm(5),jm(5),fm(5)
    
    interp_op=0
    allocate(dat(n_d(1),1), mod(n_m(1),n_m(2),n_m(3),n_m(4),1))
    nd=n_d
    nm=n_m
    nm(5)=1
    nd(2)=1
    fm=0
    fd=0
    jd=1
    jm=1
    do i5=1,n_m(5)
      fd(2)=i5-1
      fm(5)=i5-1
      write(0,*) "1NTERP",adj,i5,n_m(5)
      if(0/=sreed_window(dat_tag,2,n_d,nd,fd,jd,8,dat)) &
        call seperr("trouble reading in model")
      if(0/=sreed_window(mod_tag,5,n_m,nm,fm,jm,8,mod)) &
        call seperr("trouble reading in model")
      write(0,*) "2NTERP",adj,i5,n_m(5)
      call amo_interp(adj,add,mod,dat,head)
      write(0,*) "3NTERP",adj,i5,n_m(5)
      if(0/=srite_window(dat_tag,2,n_d,nd,fd,jd,8,dat)) &
        call seperr("trouble reading in model")
      if(0/=srite_window(mod_tag,5,n_m,nm,fm,jm,8,mod)) &
        call seperr("trouble reading in model")
      write(0,*) "4NTERP",adj,i5,n_m(5)
    end do 
    call sseek(dat_tag,0,0)
    call sseek(mod_tag,0,0)
    deallocate(mod,dat)
  end function


subroutine amo_interp(adj,add,model,data,headers)
  type(sep3d) :: mod_s,dat_s
  complex, allocatable :: model(:,:,:,:,:)
  complex, allocatable :: data(:,:)
  real, allocatable :: headers(:,:)
  integer           :: ih,i1,i2,i3,i4,nf,nh,maxsize,nblock,ndone,n(4),i
  integer           :: e1,e2,e3,e4
  real              :: f1,f2,f3,f4
  logical           :: adj,add

  if(.not. add) then
    if(.not. adj ) data=0
    if(adj ) model=0
  end if

  n(1)=size(model,1)
  n(2)=size(model,2)
  n(3)=size(model,3)
  n(4)=size(model,4)
  do ih=1,size(headers,2)



    if(i1==n(1) .and.  n(1) /= 1) then; i1=n(1)-1; f1=1.;e1=i1; end if
    i1=headers(1,ih)   ; f1=headers(1,ih)-i1;e1=i1+1
    if(i1==0)  then; i1=1; f1=0;e1=1; end if

    if(i2==n(2) .and.  n(2) /= 1) then; i2=n(2)-1; f2=1.;e2=i2; end if
    i2=headers(2,ih)   ; f2=headers(2,ih)-i2;e2=i2+1
    if(i2==0)  then; i2=1; f2=0;e2=1; end if
     
    if(i3==n(3) .and.  n(3) /= 1) then; i3=n(3)-1; f3=1.;e3=i3; end if
    i3=headers(3,ih)   ; f3=headers(3,ih)-i3;e3=i3+1
    if(i3==0)  then; i3=1; f3=0;e3=1; end if

    i4=headers(4,ih)   ; f4=headers(4,ih)-i4;e4=i4+1
    if(i4==0)  then; i4=1; f4=0;e4=1; end if
    if(i4==n(4) .and.  n(4) /= 1) then; i4=n(4)-1; f4=1.;e4=i4; end if


    if(i2 > 0 .and. ie <= n(2) .and. i1 >0 .and. e1 <= n(1) ) then
      if(i4 > 0 .and. ie <= n(4) .and. i3 >0 .and. e3 <= n(3) ) then

        if(.not. adj) then
          data(ih,:)=data(ih,:)+ &
            model(i1,i2,i3,i4,:)*(1.-f1)*(1.-f2)*(1.-f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,i3,i4,:)*(f1)*(1.-f2)*(1.-f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,i3,i4,:)*(1.-f1)*(f2)*(1.-f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,i3,i4,:)*(f1)*(f2)*(1.-f3)*(1.-f4)

          data(ih,:)=data(ih,:)+ &
            model(i1,i2,e3,i4,:)*(1.-f1)*(1.-f2)*(f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,e3,i4,:)*(f1)*(1.-f2)*(f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,e3,i4,:)*(1.-f1)*(f2)*(f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,e3,i4,:)*(f1)*(f2)*(f3)*(1.-f4)

          data(ih,:)=data(ih,:)+ &
            model(i1,i2,i3,e4,:)*(1.-f1)*(1.-f2)*(1.-f3)*(f4)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,i3,e4,:)*(f1)*(1.-f2)*(1.-f3)*(f4)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,i3,e4,:)*(1.-f1)*(f2)*(1.-f3)*(f4)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,i3,e4,:)*(f1)*(f2)*(1.-f3)*(f4)

          data(ih,:)=data(ih,:)+ &
            model(i1,i2,e3,e4,:)*(1.-f1)*(1.-f2)*(f3)*(f4)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,e3,e4,:)*(f1)*(1.-f2)*(f3)*(f4)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,e3,e4,:)*(1.-f1)*(f2)*(f3)*(f4)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,e3,e4,:)*(f1)*(f2)*(f3)*(f4)


        else
          model(i1,i2,i3,i4,:)=model(i1,i2,i3,i4,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(1.-f3)*(1.-f4)
          model(e1,i2,i3,i4,:)=model(e1,i2,i3,i4,:)+&
            data(ih,:)*(f1)*(1.-f2)*(1.-f3)*(1.-f4)
          model(i1,e2,i3,i4,:)=model(i1,e2,i3,i4,:)+&
            data(ih,:)*(1.-f1)*(f2)*(1.-f3)*(1.-f4)
          model(e1,e2,i3,i4,:)=model(e1,e2,i3,i4,:)+&
            data(ih,:)*(f1)*(f2)*(1.-f3)*(1.-f4)

          model(i1,i2,e3,i4,:)=model(i1,i2,e3,i4,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(f3)*(1.-f4)
          model(e1,i2,e3,i4,:)=model(e1,i2,e3,i4,:)+&
            data(ih,:)*(f1)*(1.-f2)*(f3)*(1.-f4)
          model(i1,e2,e3,i4,:)=model(i1,e2,e3,i4,:)+&
            data(ih,:)*(1.-f1)*(f2)*(f3)*(1.-f4)
          model(e1,e2,e3,i4,:)=model(e1,e2,e3,i4,:)+&
            data(ih,:)*(f1)*(f2)*(f3)*(1.-f4)

          model(i1,i2,i3,e4,:)=model(i1,i2,i3,e4,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(1.-f3)*(f4)
          model(e1,i2,i3,e4,:)=model(e1,i2,i3,e4,:)+&
            data(ih,:)*(f1)*(1.-f2)*(1.-f3)*(f4)
          model(i1,e2,i3,e4,:)=model(i1,e2,i3,e4,:)+&
            data(ih,:)*(1.-f1)*(f2)*(1.-f3)*(f4)
          model(e1,e2,i3,e4,:)=model(e1,e2,i3,e4,:)+&
            data(ih,:)*(f1)*(f2)*(1.-f3)*(f4)

          model(i1,i2,e3,e4,:)=model(i1,i2,e3,e4,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(f3)*(f4)
          model(e1,i2,e3,e4,:)=model(e1,i2,e3,e4,:)+&
            data(ih,:)*(f1)*(1.-f2)*(f3)*(f4)
          model(i1,e2,e3,e4,:)=model(e1,e2,e3,e4,:)+&
            data(ih,:)*(1.-f1)*(f2)*(f3)*(f4)
          model(e1,e2,e3,e4,:)=model(i1,e2,e3,e4,:)+&
            data(ih,:)*(f1)*(f2)*(f3)*(f4)
        end if
      end if
    end if

    i4=headers(5,ih)   ; f4=headers(5,ih)-i4;e4=i4+1
    if(i4==0)  then; i4=1; f4=0;e4=1; end if
    if(i4==n(4) .and.  n(4) /= 1) then; i4=n(4)-1; f4=1.;e4=i4; end if

    if(i2 > 0 .and. ie <= n(2) .and. i1 >0 .and. e1 <= n(1) ) then
      if(i4 > 0 .and. ie <= n(4) .and. i3 >0 .and. e3 <= n(3) ) then

        if(.not. adj) then
          data(ih,:)=data(ih,:)+ &
            model(i1,i2,i3,i4,:)*(1.-f1)*(1.-f2)*(1.-f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,i3,i4,:)*(f1)*(1.-f2)*(1.-f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,i3,i4,:)*(1.-f1)*(f2)*(1.-f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,i3,i4,:)*(f1)*(f2)*(1.-f3)*(1.-f4)

          data(ih,:)=data(ih,:)+ &
            model(i1,i2,e3,i4,:)*(1.-f1)*(1.-f2)*(f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,e3,i4,:)*(f1)*(1.-f2)*(f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,e3,i4,:)*(1.-f1)*(f2)*(f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,e3,i4,:)*(f1)*(f2)*(f3)*(1.-f4)

          data(ih,:)=data(ih,:)+ &
            model(i1,i2,i3,e4,:)*(1.-f1)*(1.-f2)*(1.-f3)*(f4)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,i3,e4,:)*(f1)*(1.-f2)*(1.-f3)*(f4)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,i3,e4,:)*(1.-f1)*(f2)*(1.-f3)*(f4)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,i3,e4,:)*(f1)*(f2)*(1.-f3)*(f4)

          data(ih,:)=data(ih,:)+ &
            model(i1,i2,e3,e4,:)*(1.-f1)*(1.-f2)*(f3)*(f4)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,e3,e4,:)*(f1)*(1.-f2)*(f3)*(f4)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,e3,e4,:)*(1.-f1)*(f2)*(f3)*(f4)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,e3,e4,:)*(f1)*(f2)*(f3)*(f4)


        else
          model(i1,i2,i3,i4,:)=model(i1,i2,i3,i4,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(1.-f3)*(1.-f4)
          model(e1,i2,i3,i4,:)=model(e1,i2,i3,i4,:)+&
            data(ih,:)*(f1)*(1.-f2)*(1.-f3)*(1.-f4)
          model(i1,e2,i3,i4,:)=model(i1,e2,i3,i4,:)+&
            data(ih,:)*(1.-f1)*(f2)*(1.-f3)*(1.-f4)
          model(e1,e2,i3,i4,:)=model(e1,e2,i3,i4,:)+&
            data(ih,:)*(f1)*(f2)*(1.-f3)*(1.-f4)

          model(i1,i2,e3,i4,:)=model(i1,i2,e3,i4,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(f3)*(1.-f4)
          model(e1,i2,e3,i4,:)=model(e1,i2,e3,i4,:)+&
            data(ih,:)*(f1)*(1.-f2)*(f3)*(1.-f4)
          model(i1,e2,e3,i4,:)=model(i1,e2,e3,i4,:)+&
            data(ih,:)*(1.-f1)*(f2)*(f3)*(1.-f4)
          model(e1,e2,e3,i4,:)=model(e1,e2,e3,i4,:)+&
            data(ih,:)*(f1)*(f2)*(f3)*(1.-f4)

          model(i1,i2,i3,e4,:)=model(i1,i2,i3,e4,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(1.-f3)*(f4)
          model(e1,i2,i3,e4,:)=model(e1,i2,i3,e4,:)+&
            data(ih,:)*(f1)*(1.-f2)*(1.-f3)*(f4)
          model(i1,e2,i3,e4,:)=model(i1,e2,i3,e4,:)+&
            data(ih,:)*(1.-f1)*(f2)*(1.-f3)*(f4)
          model(e1,e2,i3,e4,:)=model(e1,e2,i3,e4,:)+&
            data(ih,:)*(f1)*(f2)*(1.-f3)*(f4)

          model(i1,i2,e3,e4,:)=model(i1,i2,e3,e4,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(f3)*(f4)
          model(e1,i2,e3,e4,:)=model(e1,i2,e3,e4,:)+&
            data(ih,:)*(f1)*(1.-f2)*(f3)*(f4)
          model(i1,e2,e3,e4,:)=model(e1,e2,e3,e4,:)+&
            data(ih,:)*(1.-f1)*(f2)*(f3)*(f4)
          model(e1,e2,e3,e4,:)=model(i1,e2,e3,e4,:)+&
            data(ih,:)*(f1)*(f2)*(f3)*(f4)
        end if
      end if
    end if
  end do
  end subroutine

end module
