#!/usr/bin/env python
import sys,re,string,commands


def parse_args():
  if len(sys.argv) ==1:  
    print "read.py input=  output= [niter= seed= temp_beg= temp_end= prog=]"
    sys.exit(-1)
  input=None
  output=None
  command_line=["b.x"]
  for arg in sys.argv:
    a=re.compile("(\S+)=(\S+)").search(arg)
    if a:
      if a.group(1)=="input": input=a.group(2)
      elif a.group(1)=="output": output=a.group(2)
      else: command_line.append(arg)
  if not input or not output: 
    print  "Must provide input and output \n"
    sys.exit(-1)
  try:  f=open(input)
  except:
    print "Must provide file as first option"
    sys.exit(-1)
  command_line.append(">a.V out=%s"%output)
  lines=f.readlines()
  return lines,command_line


def parse_lines(lines):
  nameS=re.compile("^\s*(\S+)\s*$")
  prefS=re.compile("^\s*(\S+)\s+(\S+)\s*$")
  names={}
  prefs={}
  iname=0
  cur_name=None
  for line in lines:
    line=line.rstrip()
    nameL=nameS.search(line)
    prefL=prefS.search(line)
    if nameL: #NEW NAME
      cur_name=nameL.group(1)
      if not names.has_key(cur_name): 
        names[cur_name]=iname
        prefs[cur_name]={}
        iname+=1
    elif prefL:
      name=prefL.group(1)
      rate=prefL.group(2)
      if not cur_name: 
        print "First line must be a person's name"
        sys.exit(-1)
      if not names.has_key(name): 
        names[name]=iname
        prefs[name]={}
        iname+=1
      prefs[cur_name][name]=rate
  return names,prefs
        
def build_args(args,names,prefs):

  args.append("nname=%d"%len(names))
  for name,index in names.items(): args.append("name%d=%s"%(index,name))
  npref=0
  for name,pref_list in prefs.items():
     for person,pref in pref_list.items(): 
       args.append("w_i_%d=%d"%(npref,int(names[name])))
       args.append("w_j_%d=%d"%(npref,int(names[person])))
       args.append("w_v_%d=%f"%(npref,float(pref)))
       npref=npref+1
  args.append("npref=%d"%npref)
  return args
  


lines,command_line=parse_args()
names,prefs=parse_lines(lines)
command_line=build_args(command_line,names,prefs)
      stat,out=commands.getstatusoutput(string.join(command_line))
print out
 

