module transp_data_mod
  use verb_mod 
  implicit none
  integer, private, save :: maxsize

  contains

  logical function init_transp_data() 

    call from_param("maxsize",maxsize,400)
    maxsize=maxsize*1000*125

    init_transp_data=.true.
  end function
  subroutine transp_data_c(n1,n2,file1,file2,verb)
    integer :: n1,n2
    character(len=*) :: file1,file2
    complex, allocatable :: buf1(:,:),buf2(:,:)
    integer           :: i1,i2,na,nb,ndone,nblock,ib,b2,nd2
    integer,external  :: sreed_window,srite
    logical           :: verb

if(n1== 0.or. n2==0) return
    nb=maxsize/n2
    na=50*1000*500/n2
    allocate(buf2(n2,na))
    allocate(buf1(nb,n2))
    

    ndone=0

    if(.not.init_print_progress(0,n1,verb)) &
      call seperr("trouble initialzing verbosity")

    do while(ndone < n1) 
      nblock=min(n1-ndone,nb)
      if(nblock/=nb) then
        deallocate(buf1)
        allocate(buf1(nblock,n2))
      end if
    
      if(0/=sreed_window(file1,2,(/n1,n2/),(/nblock,n2/),(/ndone,0/),(/1,1/),8,buf1)) &
        call seperr("trouble reading in window")
    
      nd2=0
      do while(nd2 < nblock)
        b2=min(nblock-nd2,na)
        call print_progress("Transposing data",b2)
        do  i1=1,b2
          do i2=1,n2
            buf2(i2,i1)=buf1(i1+nd2,i2)
          end do 
        end do 
        nd2=nd2+b2
        if(8*b2*n2/=srite(file2,buf2,8*b2*n2)) &
          call seperr("trouble writing out window")
      end do
      ndone=ndone+nblock
    end do
    deallocate(buf1,buf2)
  end subroutine

end module
